/*
    HTTP probing plugin for SrvCheck.
    Copyright (C) Mateusz Viste 2010,2011,2012. All rights reserved.
*/

void SrvCheck_http(int sock, char *hostname, int port, char *url, char *ErrString, int ErrString_maxlen) {
  char request[1024];
  char answer[1024];
  int recvBytes;
  snprintf(request, 1024, "HEAD %s HTTP/1.1\r\nHost: %s:%d\r\nConnection: close\r\nCache-Control: max-age=0\r\nUser-Agent: SrvCheck/%s\r\nReferer: %s\r\n\r\n", url, hostname, port, pVer, pUrl);
  if (send(sock, request, strlen(request), 0) < 0) {
      snprintf(ErrString, ErrString_maxlen, "connection interrupted while sending the request / %s", strerror(errno));
    } else { /* receive the answer */
      recvBytes = recv(sock, answer, 1024, 0);
      if (recvBytes < 0) {
          snprintf(ErrString, ErrString_maxlen, "connection interrupted while receiving the answer / %s", strerror(errno));
        } else { /* Check the return HTTP code */
	  int x;
          for (x = 0; x < recvBytes && answer[x] != ' ' && x < 16; x++);
          if (x >= 16) {
              snprintf(ErrString, ErrString_maxlen, "HTTP answer parsing error");
            } else {
              int y = 0;
              char answercode[32];
              x++;
              for (; x < recvBytes && answer[x] != ' ' && x < 16; x++) {
                answercode[y] = answer[x];
                y++;
              }
              answercode[y] = 0;
	      if ((atoi(answercode) >= 400) || (atoi(answercode) < 100)) snprintf(ErrString, ErrString_maxlen, "got an error return code from the server (%d)", atoi(answercode));
          }
      }
  }
}
