/*
    NNTP probing plugin for SrvCheck.
    Copyright (C) Mateusz Viste 2010,2011,2012. All rights reserved.
*/

void SrvCheck_nntp(int sock, char *ErrString, int ErrString_maxlen) {
  char answer[1024];
  int recvBytes;
  recvBytes = recv(sock, answer, 1024, 0);
  if (recvBytes < 0) {
      snprintf(ErrString, ErrString_maxlen, "connection interrupted while receiving the banner / %s", strerror(errno));
    } else if (recvBytes < 4) {
      snprintf(ErrString, ErrString_maxlen, "NNTP banner too short (%d bytes)", recvBytes);
    } else { /* Check the NNTP banner */
      answer[4] = 0;
      if ((atoi(answer) < 200) || (atoi(answer) > 203)) {
          snprintf(ErrString, ErrString_maxlen, "server returned a suspect greeting code (%d)", atoi(answer));
        } else {
          if (send(sock, "QUIT\r\n", 6, 0) != 6) {
              snprintf(ErrString, ErrString_maxlen, "connection interrupted while trying to quit (%s)", strerror(errno));
            } else {
              recvBytes = recv(sock, answer, 1024, 0);
              if (recvBytes < 0) {
                  snprintf(ErrString, ErrString_maxlen, "connection interrupted while waiting for goodbye / %s", strerror(errno));
                } else if (recvBytes < 4) {
                  snprintf(ErrString, ErrString_maxlen, "NNTP goodbye too short (%d bytes)", recvBytes);
                } else {
                  answer[4] = 0;
                  if (atoi(answer) != 205) {
                    snprintf(ErrString, ErrString_maxlen, "server returned an invalid goodbye code (%d)", atoi(answer));
                  }
              }
          }
      }
  }
}
