/*
    POP3 probing plugin for SrvCheck.
    Copyright (C) Mateusz Viste 2010,2011,2012. All rights reserved.
*/

void SrvCheck_pop3(int sock, char *ErrString, int ErrString_maxlen) {
  char answer[1024];
  int recvBytes;
  recvBytes = recv(sock, answer, 1024, 0);
  if (recvBytes < 0) {
      snprintf(ErrString, ErrString_maxlen, "connection interrupted while awaiting for the banner / %s", strerror(errno));
    } else { /* check the received banner */
      if (recvBytes < 4) {
          snprintf(ErrString, ErrString_maxlen, "server banner too short (%d bytes)", recvBytes);
        } else {
          answer[3] = 0;
          if (strcasecmp(answer, "+OK") != 0) {
              snprintf(ErrString, ErrString_maxlen, "invalid banner string (%s)", answer);
            } else {
              if (send(sock, "QUIT\r\n", 6, 0) != 6) {
                  snprintf(ErrString, ErrString_maxlen, "connection broken unexpectedly");
                } else {
                  recvBytes = recv(sock, answer, 1024, 0);
                  if (recvBytes < 0) {
                      snprintf(ErrString, ErrString_maxlen, "connection interrupted while awaiting for goodbye / %s", strerror(errno));
                    } else { /* check the received goodbye code */
                      if (recvBytes < 4) {
                          snprintf(ErrString, ErrString_maxlen, "server goodbye string too short (%d bytes)", recvBytes);
                        } else {
                          answer[3] = 0;
                          if (strcasecmp(answer, "+OK") != 0) {
                            snprintf(ErrString, ErrString_maxlen, "invalid goodbye string (%s)", answer);
                          }
                      }
                  }
              }
          }
      }
  }
}
