/*
    SMTP probing plugin for SrvCheck.
    Copyright (C) Mateusz Viste 2010,2011,2012. All rights reserved.
*/

void SrvCheck_smtp(int sock, char *ErrString, int ErrString_maxlen) {
  char answer[1024];
  int recvBytes;
  recvBytes = recv(sock, answer, 1024, 0);
  if (recvBytes < 0) {
      snprintf(ErrString, ErrString_maxlen, "connection interrupted while awaiting for the banner / %s", strerror(errno));
    } else { /* check the received banner */
      if (recvBytes < 4) {
          snprintf(ErrString, ErrString_maxlen, "server banner too short (%d bytes)", recvBytes);
        } else {
          if ((answer[0] != '2') || (answer[1] != '2') || (answer[2] != '0')) {
              snprintf(ErrString, ErrString_maxlen, "invalid banner code (%c%c%c)", answer[0], answer[1], answer[2]);
            } else {

              if (send(sock, "RSET\r\n", 6, 0) != 6) {
                  snprintf(ErrString, ErrString_maxlen, "connection broken unexpectedly");
                } else {
                  recvBytes = recv(sock, answer, 1024, 0);
                  if (recvBytes < 0) {
                      snprintf(ErrString, ErrString_maxlen, "connection broken unexpectedly");
                    } else if (recvBytes < 4) {
                      snprintf(ErrString, ErrString_maxlen, "server answer too short (%d bytes)", recvBytes);
                    } else {
                      if ((answer[0] != '2') || (answer[1] != '5') || (answer[2] != '0')) {
                          snprintf(ErrString, ErrString_maxlen, "invalid answer to RSET (%c%c%c)", answer[0], answer[1], answer[2]);
                        } else {
                          if (send(sock, "QUIT\r\n", 6, 0) != 6) {
                              snprintf(ErrString, ErrString_maxlen, "connection broken unexpectedly");
                            } else {
                              recvBytes = recv(sock, answer, 1024, 0);
                              if (recvBytes < 0) {
                                  snprintf(ErrString, ErrString_maxlen, "connection interrupted while awaiting for goodbye / %s", strerror(errno));
                                } else if (recvBytes < 4) {
                                  snprintf(ErrString, ErrString_maxlen, "server goodbye code too short (%d bytes)", recvBytes);
                                } else {  /* check the received goodbye code */
                                  if ((answer[0] != '2') || (answer[1] != '2') || (answer[2] != '1')) {
                                    snprintf(ErrString, ErrString_maxlen, "invalid goodbye code (%c%c%c)", answer[0], answer[1], answer[2]);
                                  }
                              }
                          }
                      }
                  }
              }
          }
      }
  }
}
