/*
    SSH probing plugin for SrvCheck.
    Copyright (C) Mateusz Viste 2010,2011,2012. All rights reserved.
*/

void SrvCheck_ssh(int sock, char *ErrString, int ErrString_maxlen) {
  char answer[1024];
  int recvBytes;
  recvBytes = recv(sock, answer, 1024, 0);
  if (recvBytes < 0) {
      snprintf(ErrString, ErrString_maxlen, "connection interrupted while receiving the banner / %s", strerror(errno));
    } else if (recvBytes < 5) {
      snprintf(ErrString, ErrString_maxlen, "SSH banner too short (%d bytes)", recvBytes);
    } else { /* Check the SSH banner */
      if ((answer[0] != 'S') || (answer[1] != 'S') || (answer[2] != 'H') || (answer[3] != '-')) {
        snprintf(ErrString, ErrString_maxlen, "Invalid SSH banner (%c%c%c%c)", answer[0], answer[1], answer[2], answer[3]);
      }
  }
}
